/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"

/* Global typedef */

/* Global define */

/* Global Variable */
void LED_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;                //һGPIO_InitTypeDef͵Ľṹ

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);//ʹLEDصGPIO˿ʱ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1; //GPIO
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;     //GPIOģʽΪ
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;    //GPIOٶ
    GPIO_Init(GPIOA, &GPIO_InitStructure);               //ÿ⺯ʼGPIOA

    GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1);           //ߵƽ
}

void TIM5_Init(void)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5, ENABLE);       //ʹTIM1ʱ

//    TIM_TimeBaseStructure.TIM_Period = 100-1;                //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler =144-1;                //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;    //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;//TIMģʽϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM5, &TIM_TimeBaseStructure);            //ָĲʼTIMxʱλ
    *(u32*)(0x40000C2C) = 100-1;                               //TIM5װؼĴĵֵַ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM5_IRQn;            //TIM5ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;         //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure);                            //ʼNVIC

//    TIM_ClearITPendingBit(TIM5,TIM_IT_Update);
    TIM_ITConfig(TIM5,TIM_IT_Update,ENABLE );                  //ʹTIM5жϣж

    TIM_Cmd(TIM5, ENABLE); //TIM5ʹ
}
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);

    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf("This is printf example\r\n");

    LED_Init();
    TIM5_Init();

    while(1)
    {
    }
}

void TIM5_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM5_IRQHandler(void)
{
    static u8 i=0;

    if(TIM_GetITStatus(TIM5, TIM_IT_Update) != RESET) //TIM2жǷ
    {
        printf("TIM5 example\r\n");
        printf("CNT=%d\r\n",*(u32*)(0x40000C24));
        GPIO_WriteBit(GPIOA, GPIO_Pin_0, (i==0) ? (i=Bit_SET):(i=Bit_RESET));
        TIM_ClearITPendingBit(TIM5,TIM_IT_Update);      //TIM2жϹλ
    }
}


